﻿var joe = new Person { Role = Role.Customer, FirstName = "Joe", LastName = "Black" };
var john = new Person { Role = Role.Employee, FirstName = "John", LastName = "Doe" };
var jack = new Person { Role = Role.Helper, FirstName = "Jack" };

IncreaseSalary(john);
Console.WriteLine();
IncreaseSalary(joe);

void IncreaseSalary(Person person)
{
    if (person.Role is not (Role.Employee or Role.Helper))
    {
        throw new ArgumentException("Only Employee or Helper roles are supported.", nameof(person));
    }

    Console.WriteLine($"IncreaseSalary: increasing for {person} ...");
}

enum Role { Customer, Employee, Helper }

record Person
{
    public required Role Role { get; init; }
    public string? FirstName { get; set; }
    public string? LastName { get; set; }
}
